package jalview.api;

import jalview.datamodel.PDBEntry;
import jalview.datamodel.SequenceI;
import jalview.io.DataSourceType;
import jalview.io.NewickFile;

import java.io.IOException;
import java.net.URL;

public interface JalviewApp
{
  public String getParameter(String name);

  public boolean getDefaultParameter(String name, boolean def);

  public URL getDocumentBase();

  public URL getCodeBase();

  public void setAlignPdbStructures(boolean defaultParameter);

  public void newStructureView(PDBEntry pdb, SequenceI[] seqs,
          String[] chains, DataSourceType protocol);

  public void alignedStructureView(PDBEntry[] pdb, SequenceI[][] seqs,
          String[][] chains, String[] protocols);

  public void updateForAnnotations();

  public AlignViewportI getViewport();

  public void setFeatureGroupState(String[] groups, boolean state);

  public boolean parseFeaturesFile(String param, DataSourceType protocol);

  public void newFeatureSettings();

  public boolean loadScoreFile(String sScoreFile) throws IOException;

  public void loadTree(NewickFile fin, String treeFile) throws IOException;

}
